//CellNX̐錾
class Cell{

public:
	float latitude;				// ܓx [b] latitude [second]
	float longitude;				// ox [b] longitude [second]

	int down;					/* (NN1,NE2,EE3,SE4,SS5,SW6,WW7,NW8,͌0,En9,lȂ10,C-1) */
	int basin;					/* Wʐ */
	int thre_basin;				/* EWʐ */

	int numberOfUpStreamGrid;	/* 㗬Obh̐ */
	int riverNumber;			/* ͌ꂼԍŁÃObhǂ̉͌ɂȂĂ邩 */

	float longitudinalLength;	/* ox30b̒[m] */
	float med;					/* Ԓl[m] */

	class ROF* ROFCell;			/* ̃Obh܂܂~ʃZ */
	class Cell* downStreamGrid;	/* Obh */
	class Cell* upStreamGrid[7];/* 㗬Obh */

	// added on May 20, 2013
	int gridKind;	// kind of grid. 
					// -1: Edge of study region
					//  1: Inside of study region
					// 99: Dam


	bool isThisGridEnd;			/* [ObhA܂͊CObh */

	float*** mQn_memory;		/* ЂƌmQnLz */


//member and member function for kinematic wave method

	// p^
	double mMan_channel;	// Manning roughness coefficient for channel }jȎexW (m-s)
	double mMan_slope;	// Manning roughness coefficient for slope }jȎexW (m-s)
	double mKa;     // Hydraulic conductivity W (m-s)
	//double mD;      // Total Soil Layer yw (mn)
	double mDa;     // Aperturean Soil Layer 󌄕̓yw (mn)
	double mDm;     // Matrix Soil Layer }gNX̓yw (mn)
	double mBeta;   // Unsaturated Index sOaxw (-)
	double mVa;     // Velocity of Matrix Soil Layer 󌄕̓`dx (m-s)
	double mK;		// R = mK * pow(A, mZ) (mn)
	double mZ;		// R = mK * pow(A, mZ) (mn)
	double mMan;	// }jȎexW (m-s)
	double mL;		// ͓ (m)
	double mB;      // ͓ (m)
	double mG;		// ͓z (tangent ̒l)
	int mDiv;		// ԕ (-)
	double mDx;		// ԍԊu (m)
	int mDt;		// ԍԊu (sec)
	double mTheta;	// d݌W (-)
	
	int mthre_basin; // EWʐ

 	double mAlpha_slope;  // Ζʂkinematic 萔 
					 // mAlpha = 1 / mMan * pow(mK, 2/3) * sqrt(mG)
 	double mAlpha_channel;  // ͓kinematic 萔 
					 // mAlpha = 1 / mMan * pow(mK, 2/3) * sqrt(mG)

 	double mM;		// kinematic 萔
					// mM = 1 + 2/3*mZ

	// ԗ
	double* mQc;	// current_time ł̗ (m3/s)
	double* mQn;	// current_time+time_step ł̗ (m3/s)
	double mQlc;	// current_time ł̑ (m2/s)
	double mQln;	// current_time+time_step ł̑ (m2/s)


	void setElevation(int rowStep, int colStep, int row, int col, float SWlat, float SWlon, float elevation);
	void setNULL();
	void setDownStreamGrid(int row, int col, class Cell** cell2);	
	void setUpStreamGrid();
	void countNumberOfUpStreamGrid();
	void setROFCell(ROF** fROF, int row_ROF, int col_ROF);


	void initialize(double ini_lateral);
	void Set_parameter(double wMan_channel, double wMan_slope, double wKa, double wDa, double wDm, double wBeta, int wthre_basin, int x_Div, int t_Div, double theta, int t_step_num, int Ndays);

	void getLateralRunoff(int n_day, int n_hour);

	void CalculateRiver(int day, int hour, int nt);
	void CalculateBasin(int day, int hour, int nt);

	void writeQ(int year, int month, int day_num, int t_step_num, FILE *fout);
    void writeQBi(int year, int month, int day_num, int t_step_num, FILE *fout);
	float GetHourlyFlow(int day, int hour, int t_step_num);
	float GetDailyFlow(int day, int t_step_num);
	float GetHourlyFlowMax(int day, int t_step_num);
	void deleteQandA(int Ndays);
};


// added on May 20, 2013
// damCell NX̐錾 Cell NXpB
class damCell {

public:
	int damSimulationKind; // 0: use observed dam outflow, 1: use dam model
	int damCol;
	int damRow;
	class Cell* damGrid;

	double storage; // storage of dam (m3)

	double a; // model parameter
	double b; // model parameter
	double c; // model parameter
	double d; // model parameter
	double e; // model parameter

	void setDamGrid(int wDamrow, int wDamCol, int Row, int Col, int damID, class Cell** cell, int damSimulationKind);
	void setDamInitialState(double wStorage);
	void setDamParameter(double wa);
	void readDamOutflow(int iday, int t_step_num);
	void calculateDamOutflow(int day, int hour, int t_step_num);
};


